webapp/routes/clean.py
from flask import Blueprint, session, redirect, url_for, flash, current_app, render_template
import os
 
clean_bp = Blueprint('clean', __name__)

@clean_bp.route('/clean', methods=['POST'])
def clean_files():
    analysis_status = current_app.config['ANALYSIS_STATUS']
    file_metadata = current_app.config['FILE_METADATA']

    file_id = session.get('file_id')

    if not file_id:
        flash("Aucun fichier à nettoyer.", "error")
        return redirect(url_for('upload.index'))
   
    try:
        json_file = os.path.join(session['upload_folder'], file_id)
        if os.path.exists(json_file):
            os.remove(json_file)
        else:
            print("Le fichier n'existe pas")
       
        result_files = [ file['name'] for file in file_metadata[file_id]['files']]

        for file in result_files:
            if os.path.exists(file):
                os.remove(file)
       
        del analysis_status[file_id]
        del file_metadata[file_id]
        session.pop('file_id', None)
        flash("Fichiers nettoyés avec succès.", "success")

    except Exception as e:
        flash(f"Erreur lors du nettoyage : {e}", "error")
   
    return redirect(url_for('upload.index'))

webapp/routes/encodage.py
from flask import Blueprint
from flask import request, jsonify
import cchardet as chardet

encodage_bp = Blueprint('encodage', __name__)

@encodage_bp.route('/analyze_encoding', methods=['POST'])
def analyze_encoding():
    file = request.files.get('file')
    if not file:
        return jsonify({"error": "No file provided"}), 400
    
    file_data = file.read()  # Lire le contenu du fichier
    encoding_detection = chardet.detect(file_data)
    
    confidence = encoding_detection['confidence']
    encoding = encoding_detection['encoding']
    
    # Retourner l'encodage et l'indice de confiance au frontend
    return jsonify({"encoding": encoding, "confidence": confidence})

webapp/routes/files.py
from flask import Blueprint, session, flash, redirect, session, url_for, current_app, render_template, send_file
import os, io, zipfile

files_bp = Blueprint('files', __name__)
@files_bp.route('/files')
def list_files():
    analysis_status = current_app.config['ANALYSIS_STATUS']
    file_metadata = current_app.config['FILE_METADATA']

    file_id = session.get('file_id')
    if not file_id or analysis_status.get(file_id) != 'completed':
        flash("L'analyse du fichier est en cours ou a échoué.", "error")
        return redirect(url_for('upload.index'))
   
    files_info = file_metadata.get(file_id, {}).get('files', [])
    return render_template('files.html', files_info=files_info, file_id=file_id, BASE_URL=os.getenv('BASE_URL', 'http://localhost:5000'))


@files_bp.route('/results/<path:filename>')
def view_file(filename):
    analysis_status = current_app.config['ANALYSIS_STATUS']
    print(f"fichier à visualiser: {filename}")
    file_id = current_app.config['INPUT_JSON_FILE_NAME']
    if not file_id or analysis_status.get(file_id) != 'completed':
        flash("L'accès à ce fichier est interdit.", "error")
        return redirect(url_for('files.list_files'))
    
    result_file_path = filename

    if os.path.getsize(result_file_path) == 0:
        flash("Ce fichier est vide et ne peut pas être affiché.", "warning")
        return redirect(url_for('files.list_files'))
    try:
        with open(result_file_path, 'r') as file:
            content = file.read()
    except FileNotFoundError:
        flash("Fichier non trouvé", "error")
        return redirect(url_for('files.list_files'))
 
    return render_template('view_file.html', filename=filename, content=content, BASE_URL=os.getenv('BASE_URL', 'http://localhost:5000'))


@files_bp.route('/download')
def download_archive():
    file_id = session.get('file_id')
    file_metadata = current_app.config['FILE_METADATA']

    if not file_id or not file_metadata.get(file_id):
        flash("Aucun fichier trouvé pour l'archive.", "error")
        return redirect(url_for('files.list_files'))
    
    # Création de l'archive ZIP dans la mémoire
    archive_buffer = io.BytesIO()
    with zipfile.ZipFile(archive_buffer, 'w', zipfile.ZIP_DEFLATED) as zip_archive:
        for file_info in file_metadata[file_id]['files']:
            file_path = file_info['name']
            print(file_path)
            if os.path.exists(file_path) :
                if os.path.getsize(file_path) > 0 : #& os.stat(file_path).st_size > 0 :
                    zip_archive.write(file_path, arcname=os.path.basename(file_path))
                #else :
                    #print(f"{file_path} : fichier vide.")
            #else:
                #print(f"{file_path} : n'existe pas.")
    
    archive_buffer.seek(0)  # Revenir au début du fichier pour le télécharger
    
    return send_file(archive_buffer, as_attachment=True, download_name=f"{file_id}_results.zip")

webapp/routes/language.py
from flask import Blueprint, session, redirect, url_for

language_bp= Blueprint('language', __name__)

@language_bp.route('/change_language/<lang>')
def change_language(lang):
    session['lang'] = lang
    return(redirect(url_for('upload.index')))

webapp/routes/upload.py
from flask import Blueprint, flash, request, redirect, url_for, session, current_app, render_template
import os
import subprocess
import re
from routes.auth import login_required


from tools import compter_erreurs

# Fonction utilisée pour trier les résultats sur l'ordre numérique plutôt que l'ordre aphabétique
def extract_number(filename):
    # \d+    : permet de trouver tout ce qui ressemble à un nombre
    match = re.search(r'\d+', filename)
    return int(match.group()) if match else float('inf')

upload_bp = Blueprint('upload', __name__)

@upload_bp.route('/', methods=['GET'])
@login_required
def index():
    schema = current_app.config.get('SCHEMA', 'Valeur par défaut')
    return render_template('index.html', show_language_buttons=True, BASE_URL=os.getenv('BASE_URL', 'http://localhost:5000'),schema=schema)


 
@upload_bp.route('/upload', methods=['POST'])
@login_required
def upload_file():
    messages = session.get('messages', {})
    analysis_status = current_app.config['ANALYSIS_STATUS']
    file_metadata = current_app.config['FILE_METADATA']

    file = request.files.get('file')

    MAX_FILE_SIZE = 50 * 1024 * 1024  # 50 Mo en octets

    file = request.files.get('file')
    if not file or file.filename == '':
        flash(messages["flash"]["file_is_missing"], "error")
        return redirect(url_for('upload.index'))

    # Vérifier la taille du fichier
    file.seek(0, os.SEEK_END)  # Déplace le curseur à la fin du fichier pour obtenir la taille
    file_size = file.tell()
    file.seek(0)  # Remet le curseur au début pour permettre l'enregistrement

    if file_size > MAX_FILE_SIZE:
        flash(messages["flash"]["file_size_max"], "error")
        return redirect(url_for('upload.index'))

    if not file or file.filename == '':
        flash(messages["flash"]["file_is_missing"], "error")
        return redirect(url_for('upload.index'))

    file_id = current_app.config['INPUT_JSON_FILE_NAME']
    file_path = os.path.join(session['upload_folder'], file_id)
    file.save(file_path)
    result_path = os.path.join(session['results_folder'])
    result_file = os.path.join(result_path,"output_result.txt")
    vocab_control = 'vocab_control' in request.form
    simple_output = 'simple_output' in request.form
    synthesis = 'synthesis_output' in request.form
    mask_output = 'mask_output' in request.form
    hide_empty = 'hide_empty' in request.form

    # Récupérer l'encodage depuis le champs caché
    file_encoding = request.form.get('file_encoding')
    
    command = f"python3 {current_app.config['VALIDATOR_FOLDER']}/{current_app.config['VALIDATOR_SCRIPT']} {current_app.config['SCHEMA']} {file_path} {session['results_folder']} -e {file_encoding}"
    print(command)

    if vocab_control:
        command += " --cv"
    if simple_output:
        command += " --ss"
    if synthesis:
        command += " -s"
    command += f" > {result_file}"
    analysis_status[file_id] = 'in_progress'
    file_metadata[file_id] = {'hide_empty': hide_empty, 'files': []}

    try:
        result = subprocess.run(command, shell=True, check=True)

        if result.returncode == 0:
            analysis_status[file_id] = 'completed'
            print(f"L'analyse du fichier {file_id} s'est terminée avec succès.")
        else:
            error_log_path=os.path.join(session['results_folder'],"error_log.txt")
            with open(error_log_path, "r") as error_file:
                error_message = error_file.read()
            analysis_status[file_id] = 'error'
            print(f"Erreur: L'analyse du fichier {file_id} a échoué avec le code de retour {result.returncode}")
            # stockage dans la variable de session
            session['error_info'] = {
                'file_name': file.filename,
                'encoding': file_encoding,
                'error_message': error_message
            }
            flash(messages["flash"]["file_json_reading_error"], "error")
            return redirect(url_for('upload.show_json_error', file_id=file_id))


        
        sorted_files = sorted(os.listdir(result_path), key=extract_number) # tri des fichiers en prenant en compte les valeurs numériques
        for file_name in sorted_files:
            file_path = os.path.join(result_path, file_name)

            if os.path.isfile(file_path):
                file_size = os.path.getsize(file_path)

                # Si le fichier est vide et que l'option hide_empty est activée, on le supprime
                if file_size == 0 and hide_empty:
                    os.remove(file_path)
                elif  "output" in file_name and mask_output:
                    os.remove(file_path) 
                else:
                    # Si le fichier n'est pas vide (ou si hide_empty n'est pas activé), on l'ajoute
                    if file_id not in file_metadata:
                        file_metadata[file_id] = {'files': []}
                    nb_erreurs = compter_erreurs(file_path)
                    file_metadata[file_id]['files'].append({'name': file_path, 'size': file_size, 'errors': nb_erreurs})


    except subprocess.CalledProcessError as e:
        analysis_status[file_id] = 'failed'
         # Stocker les informations d'erreur dans la session
        session['error_info'] = {
            'file_name': file.filename,
            'encoding': file_encoding,
            'error_message': str(e)
            }

        # Vérifie si la sortie d'erreur est disponible
        if e.stderr:
            session['error_info']['stderr'] = e.stderr.strip()  # Capture la sortie d'erreur
        else:
            session['error_info']['stderr'] = messages["error"]["nostderr"]
        # Vérifie si la sortie standard est disponible
        if e.stdout:
            session['error_info']['stdout'] = e.stdout.strip()  # Capture la sortie standard
        else:
            session['error_info']['stdout'] = messages["error"]["nostdout"]

        flash(f"Erreur lors de l'exécution du script : {e}", "error")
        return redirect(url_for('upload.show_error', file_id=file_id))
   
    session['file_id'] = file_id
    flash(messages["flash"]["success_analyze"], "success")
    return redirect(url_for('files.list_files'))

@upload_bp.route('/upload/error/json/<file_id>')
def show_json_error(file_id):
    error_info = session.get('error_info', {})
    if not error_info:
        flash(messages["flash"]["no_error_message"], "error")
        return redirect(url_for('upload.index'))

    return render_template('json_read_error.html', error_info=error_info)


@upload_bp.route('/error/<file_id>')
def show_error(file_id):
    # Récupération des informations d'analyse depuis un stockage (par exemple `analysis_status`)
    file_info = session.get('error_info', {})
    file_name = file_info.get("file_name", "Inconnu")
    encoding = file_info.get("encoding", "Inconnu")
    error_message = file_info.get("error_message", "Erreur non spécifiée")
    stderr = file_info.get("stderr", "")
    stdout = file_info.get("stdout", "")
    error_log_path=os.path.join(session['results_folder'],"error_log.txt")
    try:
        with open(error_log_path, "r") as error_file:
            error_content = error_file.read()
    except:
            error_content = "Erreur de lecture du json, mais pas de fichier d'erreur trouvé...Vérifiez le fichier json fourni"

    return render_template('error.html', file_name=file_name, encoding=encoding, error_message=error_message, stderr=stderr, stdout=stdout, error_content=error_content, BASE_URL=os.getenv('BASE_URL', 'http://localhost:5000'))

webapp/templates/aide.html
<!DOCTYPE html>
<html lang="{{ current_lang }}">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ messages["aide"]["titre"] }}</title>
    <link rel="stylesheet" href="{{ url_for('static', filename='css/styles.css') }}">
</head>
<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
{% endwith %}
    <h1>{{ messages["aide"]["titre"] }}</h1>
    <h4>{{ messages["aide"]["sous-titre"] }}</h4>
    <ul>
        <li>{{ messages["aide"]["step1"] }}</li>
        <li>{{ messages["aide"]["step2"] }}</li>
        <li>{{ messages["aide"]["step3"] }}</li>
        <li>{{ messages["aide"]["step4"] }}</li>
        <li>{{ messages["aide"]["step5"] }}</li>
        <li>{{ messages["aide"]["step6"] }}</li>
        <li></li>
        <li>{{ messages["aide"]["step7"] }}</li>
    </ul>
    <h2 class="warning1">{{ messages["aide"]["warning1"] }}</h2>
    <h2 class="warning2">{{ messages["aide"]["warning2"] }}</h2>
    <a href="{{ url_for('upload.index') }}">{{ messages["aide"]["back_home"] }}</a>
</body>
</html>

webapp/templates/error.html
<!DOCTYPE html>
<html lang="{{ current_lang }}">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Erreur d'analyse</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/styles.css') }}">

</head>
<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
    </div>
{% endwith %}
<div class="container">
    <h1 class="mt-5">{{messages["error"]["title"]}}</h1>
    
    <div class="alert alert-danger">
        <h3>{{messages["error"]["file"]}} : <em>{{ file_name }}</em></h3>
        <h4>{{messages["error"]["encoding"]}} : {{ encoding }}</h4>
        <p><strong>{{ error_message }}</strong></p>

        {% if stderr %}
<h3>{{messages["error"]["stderr"]}} :</h3>
<pre>{{ stderr }}</pre>
{% endif %}

{% if stdout %}
<h3>{{messages["error"]["stdout"]}} :</h3>
<pre>{{ stdout }}</pre>
{% endif %}

{% if error_content %}
<h3>{{messages["error"]["script_output"]}} :</h3>
<pre>{{ error_content }}</pre>
<pre>{{ messages["error"]["comment"]}}</pre>
{% endif %}
    </div>

    <a href="{{ url_for('upload.index') }}" class="btn btn-primary">{{messages["error"]["back_home"]}}</a>
</div>

</body>
</html>

webapp/templates/files.html
<!DOCTYPE html>
<html lang="{{ current_lang }}">
 
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ messages['files']['file_list_title'] }}</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
 
<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
        </div>
{% endwith %}
<div class="container">
 
    <h1 class="mt-5">{{ messages['files']['file_list_title'] }}</h1>

    <form action="{{ url_for('clean.clean_files') }}" method="POST" class="mt-3">
        <button type="submit" class="btn btn-primary mt-3">{{ messages['files']['delete_files'] }}</button>
    </form>
    
    <table class="table table-striped mt-4">
        <thead>
            <tr>
                <th>{{ messages['files']['file_name'] }}</th>
                <th>{{ messages['files']['error_count'] }}</th>
                <th>{{ messages['files']['file_size'] }}</th>
            </tr>
        </thead>

        <tbody>
            {% for file in files_info %}
            <tr>
                <td>
                    {% if file.size > 0 %}
                    <a href="{{ url_for('files.view_file', filename=file.name) }}">{{ file.name }}</a>
                    {% else %}
                    {{ file.name }} <span class="badge badge-warning">{{ messages['files']['empty_file'] }}</span>
                    {% endif %}
                </td>
                <td>{{ file.errors }}</td>
                <td>{{ file.size }} {{ messages['files']['bytes'] }}</td>
            </tr>
            {% endfor %}
        </tbody>
        
    </table>
 
    <form action="{{ url_for('clean.clean_files') }}" method="POST" class="mt-3">
        <button type="submit" class="btn btn-primary mt-3">{{ messages['files']['delete_files'] }}</button>
    </form>
    
    <a href="{{ url_for('files.download_archive') }}" class="btn btn-success mt-3">{{ messages['files']['download_zip'] }}</a>

    
 
</div>
</body>
</html>

webapp/templates/index.html
<!DOCTYPE html>
<html lang="{{ current_lang }}">
 
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ messages['upload']['file_analysis_title'] }}</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/styles.css') }}">

</head>

<script>
    // Met à jour le texte du fichier sélectionné
    function updateButtonColor() {
        const input = document.getElementById('file');
        const fileBtn = document.getElementById('file-btn');
        const fileName = input.files.length > 0 ? input.files[0].name : "{{ messages['upload']['no_file_selected'] }}";

        document.getElementById('file-name').textContent = fileName;

        // Change la classe du bouton et le texte en fonction de la sélection du fichier
        if (input.files.length > 0) {
            fileBtn.classList.remove('file-btn-red');
            fileBtn.classList.add('file-btn-green');
            fileBtn.textContent = "{{ messages['upload']['choosen_file'] }}"
            analyzeFileEncoding(input.files[0]);
        } else {
            fileBtn.classList.remove('file-btn-green');
            fileBtn.classList.add('file-btn-red');
            fileBtn.textContent = "{{ messages['upload']['choose_file'] }}"; // Remet le texte d'origine
        }
    }

    // Fonction pour analyser l'encodage du fichier
    function analyzeFileEncoding(file) {
    const formData = new FormData();
    formData.append('file', file);

    fetch('{{ url_for("encodage.analyze_encoding") }}', {
        method: 'POST',
        body: formData
    })
    .then(response => response.json())
    .then(data => {
        if (data.error) {
            alert(data.error);
        } else {
            const encoding = data.encoding || 'Unknown';
            const confidence = data.confidence || 0;
            const encodingInfo = document.getElementById('encoding-info');

            // Affiche l'encodage et la confiance
            encodingInfo.textContent = `{{messages["encodage"]["encoding"]}}: ${encoding} ({{messages["encodage"]["confidence"]}}: ${confidence})`;

            // Change la couleur du texte en fonction de l'indice de confiance
            if (confidence > 0.5) {
                encodingInfo.style.color = 'green';
            } else {
                encodingInfo.style.color = 'red';
            }
            // Mettre à jour les champs cachés avec l'encodage détecté
            document.getElementById('file-encoding').value = encoding;
            
            // Désactiver le bouton d'envoi si la confiance est inférieure à 0.5
            const submitBtn = document.querySelector('button[type="submit"]');
            if (confidence < 0.5) {
                submitBtn.disabled = true;
                alert('{{messages["encodage"]["no_confident_message"]}}');
            } else {
                submitBtn.disabled = false;
            }
        }
    })
    .catch(error => console.error('Error:', error));
}

</script>

<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
        </div>
{% endwith %}
<div class="container">

    {% if show_language_buttons %}
<div class="form-group">
    <label>{{ messages['upload']['choose_language'] }}</label>
    <a href="{{ url_for('language.change_language', lang='fr') }}" class="btn btn-secondary">Français</a>
    <a href="{{ url_for('language.change_language', lang='en') }}" class="btn btn-secondary">English</a>
</div>
    {% endif %}

    <h1 class="mt-5">{{ messages['upload']['file_analysis_title'] }}</h1>
    <h3 class="mt-7"> {{messages['upload']['tool_description'] }} </h3>
    <h6 class="mt-7 text-right"> {{messages['upload']['used_schema_name']}} : {{ schema }} </h6>
    

    <form action="{{ url_for('upload.upload_file') }}" method="POST" enctype="multipart/form-data">
 
        <div class="form-group">
       <input type="file" name="file" id="file" accept=".json" required style="display: none;" onchange="updateButtonColor()">
        <label for="file" id="file-btn" class="btn file-btn-red">{{ messages['upload']['choose_file'] }}</label>



            <!-- Zone pour afficher le nom du fichier sélectionné -->
            <span id="file-name">{{ messages['upload']['no_file_selected'] }}</span>
            <span id="encoding-info" style="font-style: italic; margin-left: 10px;"></span>
            <!-- Champ caché pour l'encodage -->
            <input type="hidden" id="file-encoding" name="file_encoding" value="">
        </div>
 
        <div class="form-group form-check">
            <input type="checkbox" class="form-check-input" id="vocab_control" name="vocab_control" checked>
            <label class="form-check-label" for="vocab_control">{{ messages['upload']['vocab_control'] }}</label>
        </div>
 
        <!--<div class="form-group form-check">
            <input type="checkbox" class="form-check-input" id="simple_output" name="simple_output">
            <label class="form-check-label" for="simple_output">{{ messages['upload']['simple_output'] }}</label>
        </div>-->
 
        <div class="form-group form-check">
            <input type="checkbox" class="form-check-input" id="synthesis_output" name="synthesis_output">
            <label class="form-check-label" for="synthesis_output">{{ messages['upload']['synthesis_output'] }}</label>
        </div>
 
        <div class="form-group form-check">
            <input type="checkbox" class="form-check-input" id="hide_empty" name="hide_empty">
            <label class="form-check-label" for="hide_empty">{{ messages['upload']['hide_empty'] }}</label>
        </div>

        <div class="form-group form-check">
            <input type="checkbox" class="form-check-input" id="mask_output" name="mask_output" checked>
            <label class="form-check-label" for="mask_output">{{ messages['upload']['mask_output'] }}</label>
        </div>
  
        <button type="submit" class="btn btn-primary">{{ messages['upload']['analyze_button'] }}</button>

    </form>

    <div class="mt-5">
        <a href="{{ url_for('aide') }}"><button>{{ messages["upload"]["help_button"] }}</button></a>
    </div>
 
</div>

 

</body>

</html>

webapp/templates/json_read_error.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Erreur de lecture JSON</title>
</head>
<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
    </div>
{% endwith %}
    <h1>Erreur de lecture du fichier JSON</h1>
    <p><strong>Nom du fichier :</strong> {{ error_info.file_name }}</p>
    <p><strong>Encodage utilisé :</strong> {{ error_info.encoding }}</p>
    <p><strong>Détails de l'erreur :</strong></p>
    <pre>{{ error_info.error_message }}</pre>
    <a href="{{ url_for('upload.index') }}">Retour à l'accueil</a>
</body>
</html>

webapp/templates/login.html
<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <title>Connexion</title>
    <link rel="stylesheet" href="{{ url_for('static', filename='css/styles.css') }}">
</head>
<body class="login-container-body">
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
</div>
{% endwith %}
    <div class="login-container">
        <img src="{{ url_for('static', filename='logo.png') }}?text=Logo_In-Sylva" alt="Logo In-Sylva">
        
    <h2>Connexion</h2>
    <form method="POST">
        <label for="username">Identifiant :</label>
        <input type="text" name="username" required><br>
        <label for="password">Mot de passe :</label>
        <input type="password" name="password" required><br>
        <button type="submit">Se connecter</button>
    </form>
    {% with messages = get_flashed_messages(with_categories=true) %}
        {% if messages %}
        <div class="error">
            <ul>
            {% for category, message in messages %}
                <li class="{{ category }}">{{ message }}</li>
            {% endfor %}
            </ul>
        </div>
        {% endif %}
    {% endwith %}
    </div>
</body>
</html>

webapp/templates/view_file.html
<!DOCTYPE html>
<html lang="{{ current_lang }}">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ messages['view_file']['title'] }} - {{ filename }}</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="flash-messages">
        {% for category, message in messages %}
            <div class="alert alert-{{ category }}">
                {{ message }}
            </div>
        {% endfor %}
    {% endif %}
        </div>
{% endwith %}
    <div class="container">
        <div class="d-flex align-items-center mt-5">
            <h1 class="mb-0">{{ messages['view_file']['title'] }}</h1>
            <h2 class="ml-3 mb-0">{{ filename | basename }}</h2>
        </div>
        
        <a href="{{ url_for('files.list_files') }}" class="btn btn-primary mt-3">{{ messages['view_file']['back_to_list'] }}</a>
        <pre class="mt-4 p-3 bg-light border">{{ content }}</pre>
        <a href="{{ url_for('files.list_files') }}" class="btn btn-primary mt-3">{{ messages['view_file']['back_to_list'] }}</a>
    </div>
</body>
</html>